/* AdcBoard.java */

package com.ftdi.d2xx;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ListView;
import java.util.Timer;
import java.util.TimerTask;
import com.ftdi.*;

import android.widget.ArrayAdapter;

public class AdcBoard extends Activity 
{
	public TextView numDevs, devInfo, statInfo;
	public ListView listView;
	Button exitBtn, resetBtn;
   	int devCount = 0, packetCount = 0, dspStats = 0;
	D2xx ftD2xx = null;
	Timer timer = null;
	MyLogger l;
	int[] stats = new int[ 4 ];
	AdcBoard view;
		
	void onTimer()  {
		ftD2xx.getStats( stats );
		if( ++dspStats >= 100 )  {
			dspStats = 0;
			view.runOnUiThread( new Runnable() {
				public void run() {
					updateStats();
				}
			});
		}
	}
		
	int openFtdi()  {
	   	devCount = D2xx.create();
		numDevs.setText(String.format( "Number of devices: %d", devCount ) );
       	if(devCount <= 0)
			return 0;
		
		ftD2xx = new D2xx();
		if( ftD2xx == null )	
			return 0;
		if( ftD2xx.open( 0, 38400 ) == 0 )  {
			devInfo.setText("AdcBoard Open Error");
			return 0;
		}
		devInfo.setText("AdcBoard Found");
		return 1;
	}
		
	void closeApp()  {
		if( timer != null )
			timer.cancel();
		if( devCount > 0 )  {
			ftD2xx.shutDown();
		}
	}
		
	void updateStats()  {
		statInfo.setText( String.format( "Good:%d Bad:%d Cur:%d MaxQue:%d", stats[0], stats[1], 
			stats[2], stats[3] ) );			
	}
		
    @Override public void onCreate(Bundle savedInstanceState) {
		view = this;
		l = new MyLogger();
		l.logWrite("Startup");
		stats[0] = stats[1] = stats[2] = stats[3] = 0;
    	super.onCreate(savedInstanceState);
    	setContentView(R.layout.main);
			
        numDevs = (TextView)findViewById(R.id.numDevstv);
        devInfo = (TextView)findViewById(R.id.devInfotv);
		statInfo = (TextView)findViewById(R.id.datatv);
 
	   	exitBtn = (Button)findViewById(R.id.exitButton);
        exitBtn.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
				closeApp();
		   		finish();          	// terminate application
            }
        });
        
	   	resetBtn = (Button)findViewById(R.id.resetButton);
        resetBtn.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
				ftD2xx.resetStats();
            }
        });
        
		if( openFtdi() <= 0 )  {
     		devInfo.setText("Open Error");
			return;
		}			
			
		String[] strs = new String[] { "Android", "Android 1", "Android Hello World" };

//		ArrayAdapter<String> strsAdapter = new ArrayAdapter<String>( this, R.id.listItem, strs );			
		listView = (ListView)findViewById(R.id.listview);
//		listView.setAdapter( strsAdapter );
		
		timer = new Timer();
		timer.scheduleAtFixedRate(new TimerTask() {
			@Override public void run() { onTimer(); }
		}, 0, 25 );		
    }
}
